Include "wire_X.geo";
Include "wire_Y.geo";
Include "halfWire_X.geo";
Include "halfWire_Y.geo";

//Default Mesh caracteristics
x0 = 0.;
y0 = 0.;
z0 = 0.;
Mesh_R = 0.0025;
Mesh_void = 0.0470;
Mesh_pitch = Mesh_void+2*Mesh_R;
Mesh_pitchX2 = 2*Mesh_pitch;
Mesh_dim_X = 0.5;
Step = 3;
Mesh_dim_X = Step*Mesh_pitch;
wireSurf[]={};
wireSurfEdges[]={};

Printf("Mesh steps='%g', ==> size=%g'", Step, Step*Mesh_pitch);

Function mesh_design
	//Counter to get the ID of the first line created by wire module and the last one
	// in order to set boundaryLayers condition for meshing the
	//START_LINE = 0; STOP_LINE =0.;

	/*lc = LC_BL; x0=0.; y0=0.; z0=Detector_FG; dx=0.; dy=0.; dz=0.; //MESH_R/2.;
	Mesh_R = MESH_R; Mesh_void = MESH_void; Mesh_pitch = MESH_pitch; Mesh_pitchX2 = MESH_pitchX2;
	Step = STEP_tot; Mesh_dim_X = MESH_dim_X; VolY = 0.;  //wireSurfY[]={}; wireSurfEdgesY[]={}; 
	Call wire_Yaxis;
	//save volume id
	volX_0 = VolX; volY_0 = VolY;*/

	/*lc = LC_BL; x0=0.; y0= MESH_pitch; z0=Detector_FG; dx = -Mesh_pitch; dy=0.; dz=0.;
	Mesh_R = MESH_R; Mesh_void = MESH_void; Mesh_pitch = MESH_pitch; Mesh_pitchX2 = MESH_pitchX2;
	Step = STEP_tot; Mesh_dim_X = MESH_dim_X; VolX = 0.; //wireSurfX[]={}; wireSurfEdgesX[]={}; 
	Call wire_Xaxis; 

	lc = LC_BL; x0= MESH_pitch; y0=0.; z0=Detector_FG; dx=0.; dy=-Mesh_pitch+MESH_R; dz=MESH_R/2.;
	Mesh_R = MESH_R; Mesh_void = MESH_void; Mesh_pitch = MESH_pitch; Mesh_pitchX2 = MESH_pitchX2;
	Step = STEP_tot; Mesh_dim_X = MESH_dim_X; VolY = 0.;  //wireSurfY[]={}; wireSurfEdgesY[]={}; 
	Call wire_Yaxis;*/

	lc = LC_BL; x0=0.; y0=0. ; z0=Detector_FG; dx = -Mesh_pitch/2; dy=-MESH_pitch/2; dz=0.;
	Mesh_R = MESH_R; Mesh_void = MESH_void; Mesh_pitch = MESH_pitch; Mesh_pitchX2 = MESH_pitchX2;
	Step = STEP_tot; Mesh_dim_X = MESH_dim_X; VolX = 0.; WireSide = -1; 
	Call halfWire_Xaxis; 
	

	lc = LC_BL; x0= 0.; y0=0.; z0=Detector_FG; dx=-MESH_pitch/2; dy=-MESH_pitch/2; dz=0.;
	Mesh_R = MESH_R; Mesh_void = MESH_void; Mesh_pitch = MESH_pitch; Mesh_pitchX2 = MESH_pitchX2;
	Step = STEP_tot; Mesh_dim_X = MESH_dim_X; VolY = 0.; WireSide = -1; 
	Call halfWire_Yaxis;
	//Save volume id
	volX_1 = VolX; volY_1 = VolY;
	

	lc = LC_BL; x0=0.; y0= 0.; z0=Detector_FG; dx=-Mesh_pitch/2; dy=MESH_pitch/2; dz=0.;
	Mesh_R = MESH_R; Mesh_void = MESH_void; Mesh_pitch = MESH_pitch; Mesh_pitchX2 = MESH_pitchX2;
	Step = STEP_tot; Mesh_dim_X = MESH_dim_X; VolX = 0.; WireSide = 1; 
	Call halfWire_Xaxis; 
	

	lc = LC_BL; x0= 0.; y0=0.; z0=Detector_FG; dx=MESH_pitch/2; dy=-MESH_pitch/2; dz=0.;
	Mesh_R = MESH_R; Mesh_void = MESH_void; Mesh_pitch = MESH_pitch; Mesh_pitchX2 = MESH_pitchX2;
	Step = STEP_tot; Mesh_dim_X = MESH_dim_X; VolY = 0.; WireSide = 1; 
	Call halfWire_Yaxis;
	//save volume id
	volX_2 = VolX; volY_2 = VolY;
	
	//vol_union_1 = BooleanUnion {Volume{volX_0}; Delete;} {Volume{volY_0}; Delete;};
	//vol_union_2 = BooleanUnion {Volume{volX_1}; Delete;} {Volume{volY_0}; Delete;};
	vol_union_3 = BooleanUnion {Volume{volY_1}; Delete;} {Volume{volX_1}; Delete;}; 
	vol_union_4 = BooleanUnion {Volume{volX_2}; Delete;} {Volume{vol_union_3}; Delete;};
	vol_union = BooleanUnion {Volume{volY_2}; Delete;} {Volume{vol_union_4}; Delete;};

	//Transfinite Volume{vol_union};

	/*div=6;
	PI = 3.14159;
	step_l = 2*MESH_R;
	div_l = MESH_pitchX2/step_l;
	borne_inf = -2*MESH_R;
	borne_sup = 2*MESH_R;

	For i In {0:div-1}
		x = MESH_R*Cos(i*PI/div);
		y = MESH_R*Sin(i*PI/div);

		For j In {0:div_l}
			z = -MESH_pitch+step_l*j;

			If(z<borne_inf)
				If(z>borne_sup)
						pY = newp; Point(pY) = {x, z, y, lc};
						//Point{pY} In Volume{vol_union};
						pX = newp; Point(pX) = {z, x, y, lc};
						//Point{pX} In Volume{vol_union};
				EndIf
			EndIf
		EndFor
	EndFor*/

	wireSurf[] = Boundary{ Volume{vol_union}; }; //Mesh surface boundary elements
	wireSurfEdges[] = {}; 
	Printf("Surface=", wireSurf[]);
	For i In {0:#wireSurf[]-1}
		wireSurf[i] = Abs(wireSurf[i]);
		wireSurfEdges_tmp[] = Boundary{ Surface{wireSurf[i]}; };
		wireSurfEdges[]+=Boundary{ Surface{wireSurf[i]}; };

		If(#wireSurfEdges_tmp[]==4)	//If surface edges==4, then it is a cylinder
			wireSurfCylinder[]+=wireSurf[i];
			Printf("Surface is a cylinder=%f", wireSurf[i]);
		EndIf
		//wirePts+=PointsOf{ Volume{vol_union}; };
	EndFor

	For i In {0:#wireSurfEdges[]-1}
		wireSurfEdges[i] = Abs(wireSurfEdges[i]);
	EndFor

	Printf("EdgesList=", wireSurfEdges[]);

	//Printf("Points list=", wirePts[]);
	Printf("Mesh_volume=%g", vol_union);
	Physical Volume("mesh_volume") = { vol_union };
	Physical Surface("mesh_surface") = {wireSurf[]};


Return 
