//Default Mesh caracteristics
lc = 0.1;
x0 = 0.; dx = 0.;
y0 = 0.; dy = 0.;
z0 = 0.; dz = 0.;
Mesh_R = 0.0025;
Mesh_void = 0.0470;
Mesh_pitch = Mesh_void+2*Mesh_R;
Mesh_pitchX2 = 2*Mesh_pitch;
Mesh_dim_X = 0.5;
Step = 3;
Mesh_dim_X = Step*Mesh_pitch;
VolX = 0;
WireSide = -1;

Function halfWire_Xaxis

	Printf("Start creating half wire X");
	
	p_ctr = newp; Point(p_ctr) = {x0+dx, y0+dy, z0+dz, lc};
	p1 = newp; Point(p1) = {x0+dx, y0+dy, z0+dz+Mesh_R, lc};
	p2 = newp; Point(p2) = {x0+dx, y0+dy, z0+dz-Mesh_R, lc};
	edgeC[]={};
	   
	If(WireSide == -1)
		Printf("Half-wire X negative side, x=%g, y=%g, z=%g", x0+dx+Mesh_R, y0+dy, z0+dz);
		p0 = newp; Point(p0) = {x0+dx, y0+dy+Mesh_R, z0+dz, lc};
		c1=newl; edgeC[]+=c1; Circle(c1) = {p2, p_ctr, p0};
		c2=newl; edgeC[]+=c2; Circle(c2) = {p0, p_ctr, p1};
		c3=newl; edgeC[]+=c3; Line(c3) = {p1,p2};
	Else
		Printf("Half-wire X positive side, x=%g, y=%g, z=%g", x0+dx+Mesh_R, y0+dy, z0+dz);
		p0 = newp; Point(p0) = {x0+dx, y0+dy-Mesh_R, z0+dz, lc};
		c1=newl; edgeC[]+=c1; Circle(c1) = {p2, p_ctr, p0};
		c2=newl; edgeC[]+=c2; Circle(c2) = {p0, p_ctr, p1};
		c3=newl; edgeC[]+=c3; Line(c3) = {p1,p2};
	EndIf

	ll1=newll; Line Loop(ll1) = { edgeC[] };
	ps1=news; Plane Surface(ps1) = {ll1}; /// bottom surface number

	//extrude the geometry + the mesh ==> Layer=extrude the mesh with an subdivision number per layer to extrude 2d mesh
	// ext_out[0]= top surface number, ext_out[1]= volume number, ext_out[]= lateral surface number
	ext_out[] = Extrude{Mesh_pitch, 0., 0.}{Surface{ps1};}; 
	VolX = ext_out[1];
	
Return
